Page MenuHomePhabricator

Support Amazon payments initiated off paymentswiki
Closed, ResolvedPublic2 Estimated Story Points

Description

When we get an Amazon payment and don't have a pending message, let's use their API to look up donor details.

We need this to accept payments via Alexa.

Event Timeline

Ejegg created this task.May 9 2018, 9:48 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 9 2018, 9:48 PM
Ejegg added a comment.May 10 2018, 2:08 AM

So this is an opportunity to make the Amazon flow more like the Adyen flow, where we combine the donor details from the pending DB in a separate job before sending the data to the donations queue. The Amazon version of the RecordCapture job should first look in the pending DB, then if the details aren't there, ask Amazon.

To ask Amazon, call getOrderReferenceDetails with amazon_order_reference_id set to the amazon-side ID, then use the details in the response
$getDetailsResult['GetOrderReferenceDetailsResult']['OrderReferenceDetails']['Buyer'] has properties 'Email' and 'Name'. We have to split first_name and last_name out of the name field.

Vvjjkkii renamed this task from Support Amazon payments initiated off paymentswiki to m9caaaaaaa.Jul 1 2018, 1:11 AM
Vvjjkkii triaged this task as High priority.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed a subscriber: Aklapper.
Vachovec1 renamed this task from m9caaaaaaa to Support Amazon payments initiated off paymentswiki.Jul 1 2018, 3:37 PM
Vachovec1 raised the priority of this task from High to Needs Triage.

Change 460468 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[wikimedia/fundraising/SmashPig@master] WIP Amazon RecordPaymentJob

https://gerrit.wikimedia.org/r/460468

Ejegg claimed this task.Sep 14 2018, 4:15 AM
Ejegg triaged this task as High priority.
Ejegg set the point value for this task to 2.

Change 461830 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[wikimedia/fundraising/SmashPig@master] Don't stop action chain if CloseOrderReference fails

https://gerrit.wikimedia.org/r/461830

Change 461833 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[wikimedia/fundraising/SmashPig@master] WIP send Amazon capture messages to jobs-amazon

https://gerrit.wikimedia.org/r/461833

Change 460468 merged by jenkins-bot:
[wikimedia/fundraising/SmashPig@master] Amazon RecordPaymentJob

https://gerrit.wikimedia.org/r/460468

Change 461833 merged by jenkins-bot:
[wikimedia/fundraising/SmashPig@master] Send Amazon capture messages to jobs-amazon

https://gerrit.wikimedia.org/r/461833

Change 461830 merged by Ejegg:
[wikimedia/fundraising/SmashPig@master] Don't stop action chain if CloseOrderReference fails

https://gerrit.wikimedia.org/r/461830

Change 463508 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[wikimedia/fundraising/SmashPig@master] Amazon audit: fix IDs for donations started off-wiki

https://gerrit.wikimedia.org/r/463508

Change 463508 merged by jenkins-bot:
[wikimedia/fundraising/SmashPig@master] Amazon audit: fix IDs for donations started off-wiki

https://gerrit.wikimedia.org/r/463508

Change 463882 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[wikimedia/fundraising/crm@master] Amazon audit: donations without log data go to jobs-amazon

https://gerrit.wikimedia.org/r/463882

Change 463882 merged by jenkins-bot:
[wikimedia/fundraising/crm@master] Amazon audit: donations without log data go to jobs-amazon

https://gerrit.wikimedia.org/r/463882

Ejegg closed this task as Resolved.Oct 16 2018, 8:17 PM